let sessionNumber = 8;
require('geckodriver');
// Generated by Selenium IDE
const { Builder, By, Key, until } = require('selenium-webdriver')
const firefox = require('selenium-webdriver/firefox');
const { performance } = require('perf_hooks');
const assert = require('assert');
const fs = require('fs');
const path = require('path');
const chai = require('chai');
const expect = chai.expect;

const data = fs.readFileSync('./test/grading.json');
const jsonData = JSON.parse(data);

if(!jsonData.gradedTest.s08){

	try {

      if (!fs.existsSync('./sessions/frontend/s08/activity/index.html')) {
			throw new Error('File not found');
		  }

      //Automated Grading Integration
      // Variable to store passing unit test scores for the session
      let passingTests = 0;
      // Variable to store total number of session unit tests
      let totalTests = 0;


      function parsePixels(value) {
          return parseFloat(value.replace('px', ''));
        }

      describe('s08', function() {

        this.timeout(30000);
        const timeout = 10000;
        let driver;
        let vars;

        let internalCssTestPassed = false;

        let startTime;
        let errors = [];
        before(async function() {
          startTime = performance.now();
          // Any setup code you need to run before the tests start
          driver = await new Builder().forBrowser('firefox').setFirefoxOptions(options).build()
        });

        const options = new firefox.Options();
        options.headless();
  
        options.setPreference('browser.download.manager.showWhenStarting', false);
        options.setPreference('browser.download.manager.useWindow', false);
  
        beforeEach(async function() {

          totalTests += 1;
          vars = {}
        })
  
        afterEach(function(){
  
          if(this.currentTest.state === "passed"){
            passingTests += 1;
          }
  
          process.removeAllListeners(); 

          if (this.currentTest.state === 'failed') {
            errors.push({
                test: this.currentTest.title,
                feedback: this.currentTest.err.message
            });
        }
  
        })

        it('pre-footer has 1 rem, bg colors and white text', async function() {

          const filePath = path.join(__dirname, '..','sessions','frontend','s08','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

              // Find the pre-footer section by id
              const preFooterSection = await driver.findElement(By.id('pre-footer'));
              // Get REM value
              const rem = await driver.findElement(By.css('html')).getCssValue('font-size');
              // Get the CSS styles of the pre-footer section
              const padding = await preFooterSection.getCssValue('padding');
              const bgColor = await preFooterSection.getCssValue('background-color');
              const color = await preFooterSection.getCssValue('color');
              
              expect(padding,"padding is not equal to rem").to.equal(rem);
              expect(bgColor,"bg color is not as instructed").to.equal('rgb(0, 37, 64)');
              expect(color,"text color should be white.").to.equal('rgb(255, 255, 255)');

        });

        it('div inside pre-footer section is inline-block and width is 20%', async function() {
         
              const filePath = path.join(__dirname, '..','sessions','frontend','s08','activity','index.html');
              const url = `file://${filePath}`;
              await driver.get(url);

              const preFooterDivs = await driver.findElements(By.css('#pre-footer > div'));
              const preFooterSection = await driver.findElement(By.id('pre-footer'));

              const parentWidth = await preFooterSection.getCssValue('width').then(parsePixels);
              const parentPaddingLeft = await preFooterSection.getCssValue('padding-left').then(parsePixels);
              const parentPaddingRight = await preFooterSection.getCssValue('padding-right').then(parsePixels);

              const expectedWidth = Math.floor((parentWidth - (parentPaddingLeft + parentPaddingRight)) * 0.2);

              for(let i = 0; i < preFooterDivs.length; i++){

                  
                  const divDisplay = await preFooterDivs[i].getCssValue('display')
                  const divWidth = Math.floor(await preFooterDivs[i].getCssValue('width').then(parsePixels));

                  expect(divDisplay).to.equal('inline-block',"display is not inline-block");
                  expect(divWidth).to.be.at.least(expectedWidth,"div width is not equal to 20% of parent width");
              }

        });


        it('elems inside div in pre-footer section has 0.3 rem margin-top and margin-bottom.', async function() {
          
          const filePath = path.join(__dirname, '..','sessions','frontend','s08','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

          //get all elements in div
          const divElements = await driver.findElements(By.css('#pre-footer > div > *'));

          // Get REM value
          const rem = await driver.findElement(By.css('html')).getCssValue('font-size').then(parsePixels);
    
          //check elem margin top and bottom
          for(let i = 0; i < divElements.length; i++){

              
              const elemMTop = await divElements[i].getCssValue('margin-top').then(parsePixels)
              const elemMBot = await divElements[i].getCssValue('margin-bottom').then(parsePixels);

              expect(elemMTop).be.at.least(rem * 0.3,"An element margin top is not equal to 0.3rem");
              expect(elemMBot).be.at.least(rem * 0.3,"An element margin bottom is not equal to 0.3rem");
          }

        });

        it('footer has .7rem padding', async function() {
          
          const filePath = path.join(__dirname, '..','sessions','frontend','s08','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

          //get all elements in div
          const footerElement = await driver.findElement(By.css('footer'));

          // Get REM value
          const rem = await driver.findElement(By.css('html')).getCssValue('font-size').then(parsePixels);
          const footerPadding = await footerElement.getCssValue('padding').then(parsePixels);

          expect(footerPadding).be.at.least(rem * 0.7,"Footer padding is not equal to 0.7rem");

        });

        it('footer has .5rem margin-left and margin-right', async function() {
          
          const filePath = path.join(__dirname, '..','sessions','frontend','s08','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

          //get all elements in div
          const divElements = await driver.findElements(By.css('footer span'));

          // Get REM value
          const rem = await driver.findElement(By.css('html')).getCssValue('font-size').then(parsePixels);
    
          //check elem margin top and bottom
          for(let i = 0; i < divElements.length; i++){

              
              const elemMTop = await divElements[i].getCssValue('margin-left').then(parsePixels)
              const elemMBot = await divElements[i].getCssValue('margin-right').then(parsePixels);

              expect(elemMTop).be.at.least(rem * 0.5,"An element margin top is not equal to 0.3rem");
              expect(elemMBot).be.at.least(rem * 0.5,"An element margin bottom is not equal to 0.3rem");
          }

        });
        
        after(async function () {

          const endTime = performance.now();
          const totalTime = (endTime - startTime) / 1000; // Convert to seconds
          console.log(`Total time taken: ${totalTime} seconds`);
          
          global.gradesObject["s08"] = {
            grade: `${passingTests/totalTests >= 0.75 ? "P" : "F"}`,
            score: `${passingTests}/${totalTests}`,
            feedback: errors.length ? errors : "No Errors"
          }

          jsonData.gradedTest.s08 = true;
          await fs.writeFileSync('./test/grading.json', JSON.stringify(jsonData,null,4));

          await driver.quit(); 

        });

      })	


    } catch (err) {
      if(err.code === "MODULE_NOT_FOUND" || err.message === "File not found"){
        console.error(`s${sessionNumber} cannot be found. Check activity folder.`);
      } else {
        console.log(err)
      }
    }
} else {
	console.log("s08 - Tested");
}






